<?php
class ControllerExtensionPaymentMorune extends Controller
{
	private $error = array();

	public function index()
	{
		$this->load->language('extension/payment/morune');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {


			if (empty($this->request->post['payment_morune_additional']) || empty($this->request->post['payment_morune_secret']) || empty($this->request->post['payment_morune_shop_id'])) {

				$this->request->post['payment_morune_status'] = 0;

			}

			$this->model_setting_setting->editSetting('payment_morune', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
		}

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/payment/morune', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['action'] = $this->url->link('extension/payment/morune', 'user_token=' . $this->session->data['user_token'], true);
		$data['payments'] = $this->url->link('extension/payment/morune/payments', 'user_token=' . $this->session->data['user_token'], true);
		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);

		if (isset($this->request->post['payment_morune_total'])) {
			$data['payment_morune_total'] = $this->request->post['payment_morune_total'];
		} else {
			$data['payment_morune_total'] = $this->config->get('payment_morune_total');
		}

		if (isset($this->request->post['payment_morune_additional'])) {
			$data['payment_morune_additional'] = $this->request->post['payment_morune_additional'];
		} else {
			$data['payment_morune_additional'] = $this->config->get('payment_morune_additional');
		}

		if (isset($this->request->post['payment_morune_shop_id'])) {
			$data['payment_morune_shop_id'] = $this->request->post['payment_morune_shop_id'];
		} else {
			$data['payment_morune_shop_id'] = $this->config->get('payment_morune_shop_id');
		}

		if (isset($this->request->post['payment_morune_secret'])) {
			$data['payment_morune_secret'] = $this->request->post['payment_morune_secret'];
		} else {
			$data['payment_morune_secret'] = $this->config->get('payment_morune_secret');
		}

		if (isset($this->request->post['payment_morune_order_status_id'])) {
			$data['payment_morune_order_status_id'] = $this->request->post['payment_morune_order_status_id'];
		} else {
			$data['payment_morune_order_status_id'] = $this->config->get('payment_morune_order_status_id');
		}

		if (isset($this->request->post['payment_morune_failed_order_status_id'])) {
			$data['payment_morune_failed_order_status_id'] = $this->request->post['payment_morune_failed_order_status_id'];
		} else {
			$data['payment_morune_failed_order_status_id'] = $this->config->get('payment_morune_failed_order_status_id');
		}

		if (isset($this->request->post['payment_morune_success_order_status_id'])) {
			$data['payment_morune_success_order_status_id'] = $this->request->post['payment_morune_success_order_status_id'];
		} else {
			$data['payment_morune_success_order_status_id'] = $this->config->get('payment_morune_success_order_status_id');
		}

		if (isset($this->request->post['payment_morune_return_order_status_id'])) {
			$data['payment_morune_return_order_status_id'] = $this->request->post['payment_morune_return_order_status_id'];
		} else {
			$data['payment_morune_return_order_status_id'] = $this->config->get('payment_morune_return_order_status_id');
		}

		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post['payment_morune_geo_zone_id'])) {
			$data['payment_morune_geo_zone_id'] = $this->request->post['payment_morune_geo_zone_id'];
		} else {
			$data['payment_morune_geo_zone_id'] = $this->config->get('payment_morune_geo_zone_id');
		}

		$this->load->model('localisation/geo_zone');

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['payment_morune_status'])) {
			$data['payment_morune_status'] = $this->request->post['payment_morune_status'];
		} else {
			$data['payment_morune_status'] = $this->config->get('payment_morune_status');
		}

		if (isset($this->request->post['payment_morune_sort_order'])) {
			$data['payment_morune_sort_order'] = $this->request->post['payment_morune_sort_order'];
		} else {
			$data['payment_morune_sort_order'] = $this->config->get('payment_morune_sort_order');
		}

		if (isset($this->request->post['payment_morune_title'])) {
			$data['payment_morune_title'] = $this->request->post['payment_morune_title'];
		} else {
			$data['payment_morune_title'] = $this->config->get('payment_morune_title');
		}

		if (isset($this->request->post['payment_morune_services'])) {
			$data['payment_morune_services'] = $this->request->post['payment_morune_services'];
		} else {
			$data['payment_morune_services'] = $this->config->get('payment_morune_services');
		}

		$data['all_payment_morune_services'] = [];

		if (!empty($data['payment_morune_shop_id']) && !empty($data['payment_morune_secret'])) {

			$data['all_payment_morune_services'] = $this->getPaymentTariffs($data['payment_morune_shop_id'], $data['payment_morune_secret']);

		}

		$this->load->model('localisation/language');

		$data['languages'] = $this->model_localisation_language->getLanguages();


		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$data['user_token'] = $this->session->data['user_token'];

		$this->response->setOutput($this->load->view('extension/payment/morune', $data));
	}

	protected function validate()
	{
		$this->load->language('extension/payment/morune');

		if (!$this->user->hasPermission('modify', 'extension/payment/morune')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (empty($this->request->post['payment_morune_additional']) || empty($this->request->post['payment_morune_secret']) || empty($this->request->post['payment_morune_shop_id'])) {

			$this->error['warning'] = $this->language->get('error_inputs');

		}

		if(!isset($this->request->post['payment_morune_services']) || empty($this->request->post['payment_morune_services'])) {

			$this->error['warning'] = $this->language->get('error_services');

		}

		return !$this->error;
	}

	function install()
	{

		$this->load->model('setting/setting');

		$data = $this->model_setting_setting->getSetting('payment_morune');

		if (empty($data)) {

			$this->db->query("CREATE TABLE `" . DB_PREFIX . "morune_log` (`id` int NOT NULL AUTO_INCREMENT, `time` int NOT NULL, `order_id` int NOT NULL, `data` varchar(2000) NOT NULL, PRIMARY KEY (`id`)) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3");
			$this->db->query("CREATE TABLE `" . DB_PREFIX . "morune_payments` ( `id` int NOT NULL AUTO_INCREMENT, `time` int NOT NULL, `morune_id` varchar(255) NOT NULL, `order_id` int NOT NULL, `status` varchar(50) NOT NULL, `amount` varchar(100) NOT NULL, `expired` varchar(50) NOT NULL,`currency` varchar(5) NOT NULL, `url` varchar(255) NOT NULL, PRIMARY KEY (`id`)) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3");

		}

	}

	public function payments()
	{


		$this->load->language('extension/payment/morune');
		$this->load->model('extension/payment/morune');

		$this->document->setTitle($this->language->get('payments_title'));

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/payment/morune', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('payments_title'),
			'href' => $this->url->link('extension/payment/morune/payments', 'user_token=' . $this->session->data['user_token'], true)
		);

		if (isset($this->request->get['page'])) {
			$page = (int) $this->request->get['page'];
		} else {
			$page = 1;
		}

		$filter_data = array(
			'start' => ($page - 1) * $this->config->get('config_limit_admin'),
			'limit' => $this->config->get('config_limit_admin')
		);

		$total = $this->model_extension_payment_morune->getTotalPayments();

		$data['payments'] = $this->model_extension_payment_morune->getPayments($filter_data);

		$pagination = new Pagination();
		$pagination->total = $total;
		$pagination->page = $page;
		$pagination->limit = $this->config->get('config_limit_admin');
		$pagination->url = $this->url->link('extension/payment/morune/payments', 'user_token=' . $this->session->data['user_token'] . '&page={page}', true);

		$data['pagination'] = $pagination->render();

		$data['results'] = sprintf($this->language->get('text_pagination'), ($total) ? (($page - 1) * $this->config->get('config_limit_admin')) + 1 : 0, ((($page - 1) * $this->config->get('config_limit_admin')) > ($total - $this->config->get('config_limit_admin'))) ? $total : ((($page - 1) * $this->config->get('config_limit_admin')) + $this->config->get('config_limit_admin')), $total, ceil($total / $this->config->get('config_limit_admin')));

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$data['user_token'] = $this->session->data['user_token'];

		$this->response->setOutput($this->load->view('extension/payment/morune_list', $data));


	}

	function getPaymentTariffs($shopId, $apiKey)
	{

		$url = "https://api.morune.com/shops/{$shopId}/payment-tariffs";
		$tariffs = [];

		$headers = [
			"accept: application/json",
			"x-api-key: {$apiKey}"
		];

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$response = curl_exec($ch);
		curl_close($ch);

		$data = json_decode($response, true);

		if (is_array($data) && isset($data['status']) && $data['status'] == 200) {

			foreach ($data['data']['tariffs'] as $tariff) {

				if ($tariff['status'] == 'enabled') {

					$tariffs[] = [

						'name' => $tariff['service_label'],
						'value' => $tariff['service'],

					];

				}

			}

		}

		return $tariffs;
	}

	function getTariffs()
	{

		$json = [
			'error' => false
		];

		if (!isset($this->request->post['shopId']) || empty($this->request->post['shopId'])) {

			$json = [
				'error' => true
			];

		}

		if (!isset($this->request->post['secret']) || empty($this->request->post['secret'])) {

			$json = [
				'error' => true
			];

		}

		if (!$json['error']) {

			$json['data'] = $this->getPaymentTariffs($this->request->post['shopId'], $this->request->post['secret']);

		}

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));

	}

	function getPayment()
	{

		$json = [
			'error' => false
		];

		if (!isset($this->request->post['id']) || empty($this->request->post['id'])) {

			$json = [
				'error' => true
			];

		}

		if (!$json['error']) {

			$this->load->model('extension/payment/morune');

			$secret = $this->config->get('payment_morune_secret');
			$shop_id = $this->config->get('payment_morune_shop_id');

			$url = "https://api.morune.com/invoice/info";
			$headers = [
				"accept: application/json",
				"x-api-key: {$secret}"
			];
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, "$url?invoice_id={$this->request->post['id']}&shop_id={$shop_id}");
			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			$response = curl_exec($ch);
			curl_close($ch);

			$data = json_decode($response, true);

			if (is_array($data) && isset($data['status']) && $data['status'] == 200) {

				foreach($data['data'] as $item=>$value) {

					if(is_null($value)) {
                       $json['data'][$item] = '';
					} else {
                       $json['data'][$item] = $value;
					}

				}
				
				$this->model_extension_payment_morune->updateTransaction($data['data']);
 
			} else {

				$json['data'] = false;

			}

		}

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));

	}
}