<?php
class ModelExtensionPaymentMorune extends Model
{
	public function getMethod($address, $total)
	{
		$this->load->language('extension/payment/morune');

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int) $this->config->get('payment_morune_geo_zone_id') . "' AND country_id = '" . (int) $address['country_id'] . "' AND (zone_id = '" . (int) $address['zone_id'] . "' OR zone_id = '0')");

		if ($this->config->get('payment_morune_total') > 0 && $this->config->get('payment_morune_total') > $total) {
			$status = false;
		} elseif (!$this->cart->hasShipping()) {
			$status = false;
		} elseif (!$this->config->get('payment_morune_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

		$method_data = array();

		$payment_morune_title = $this->config->get('payment_morune_title');

		if (is_array($payment_morune_title) && isset($payment_morune_title[(int) $this->config->get('config_language_id')]) && !empty($payment_morune_title[(int) $this->config->get('config_language_id')])) {
			$title = $payment_morune_title[(int) $this->config->get('config_language_id')];
		} else {
			$title = $this->language->get('text_title');
		}


		if ($status) {
			$method_data = array(
				'code' => 'morune',
				'title' => $title,
				'terms' => '',
				'sort_order' => $this->config->get('payment_morune_sort_order')
			);
		}

		return $method_data;
	}

	public function log($order_id, $responce)
	{

		$this->db->query("INSERT INTO `" . DB_PREFIX . "morune_log`( `time`, `order_id`, `data`) VALUES ( '" . time() . "','" . (int) $order_id . "','" . $this->db->escape($responce) . "')");

	}

	public function saveTransaction($order_id, $data)
	{

		$morune_id = isset($data['data']['id']) ? $data['data']['id'] : '';
		$status = 'created';
		$amount = isset($data['data']['amount']) ? $data['data']['amount'] : '';
		$expired = isset($data['data']['expired']) ? $data['data']['expired'] : '';
		$currency = isset($data['data']['currency']) ? $data['data']['currency'] : '';
		$url = isset($data['data']['url']) ? $data['data']['url'] : '';

		if (!empty($morune_id)) {

			$this->db->query("INSERT INTO `" . DB_PREFIX . "morune_payments`( `time`, `morune_id`, `order_id`, `status`, `amount`, `expired`, `currency`, `url` ) VALUES ('" . time() . "', '" . $this->db->escape($morune_id) . "', '" . (int) $order_id . "', '" . $this->db->escape($status) . "', '" . $this->db->escape($amount) . "', '" . $this->db->escape($expired) . "', '" . $this->db->escape($currency) . "', '" . $this->db->escape($url) . "')");

		}

	}

	public function updateTransaction($order_id, $data)
	{

		$morune_id = isset($data['invoice_id']) ? $data['invoice_id'] : '';
		$status = isset($data['status']) ? $data['status'] : '';
		$amount = isset($data['amount']) ? $data['amount'] : '';

		if (!empty($morune_id) && (int) $order_id) {

			$this->db->query("UPDATE `" . DB_PREFIX . "morune_payments` SET `status`='" . $this->db->escape($status) . "',`amount`='" . $this->db->escape($amount) . "' WHERE `order_id` = '" . (int) $order_id . "' AND `morune_id` = '" . $this->db->escape($morune_id) . "'");

		}

	}
}
